﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using GamblerSimulator.Properties;

namespace GamblerSimulator
{
    public partial class MainForm : Form
    {
        private const int Stake = 100;
        private const int Reward1 = 500;
        private const int Reward2 = 2000;
        private const int Reward3 = 5000;

        private readonly Random _rand = new Random(DateTime.Now.Millisecond);

        public MainForm()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            machineMoney.SetMoneyValue(_rand.Next(10000, 100000));
            myMoney.SetMoneyValue(_rand.Next(1000, 10000));
        }

        private void run_Click(object sender, EventArgs e)
        {
            if (myMoney.GetMoneyValue() < Stake)
            {
                MessageBox.Show(Resources.YouLose);
                return;
            }

            myMoney.TakeMoney(Stake);
            youLost.GiveMoney(Stake);
            machineMoney.GiveMoney(Stake);

            Label[] avts = { avt1, avt2, avt3, avt4, avt5 };
            var avtValues = new List<int>();
            foreach (var avt in avts)
            {
                var value = _rand.Next(1, 10);
                avt.SetMoneyValue(value, 1);
                avtValues.Add(value);
            }
            avtValues.Sort();

            var lastNum = 0;
            var currentEquals = 0;
            var maxEquals = 0;
            foreach (var a in avtValues)
            {
                if (a == lastNum)
                {
                    currentEquals++;
                    if (currentEquals > maxEquals)
                    {
                        maxEquals = currentEquals;
                    }
                }
                else
                {
                    lastNum = a;
                    currentEquals = 0;
                }
            }

            var reward = 0;
            // ReSharper disable once SwitchStatementMissingSomeCases
            switch (maxEquals)
            {
                case 4:
                    reward = Reward3;
                    break;
                case 3:
                    reward = Reward2;
                    break;
                case 2:
                    reward = Reward1;
                    break;
            }

            // ReSharper disable once InvertIf
            if (reward > 0)
            {
                if (machineMoney.GetMoneyValue() > reward)
                {
                    myMoney.GiveMoney(reward);
                    youWon.GiveMoney(reward);
                    machineMoney.TakeMoney(reward);
                }
                else
                {
                    MessageBox.Show(Resources.CasinoLose);
                }
            }
        }
    }
}
